//+------------------------------------------------------------------+
//|                                                 VininE Numer.mq4 |
//|                      Copyright  2008, Victor Nicolaev aka Vinin |
//|                                           skype: victor.nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008 Victor Nicolaev"
#property link      "vinin@mail.ru"

//---- INPUT PARAMETERS


extern double Lots = 0.1;
extern double MaximumRisk=5.0;

int MagicNumber = 0;            // Use 3 different magic number for 3 different lot size

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()  {
   MathSrand(TimeLocal());
   return(0);
 }

int deinit() {return(0);}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   static int prevtime=0;
   if(iTime(Symbol(),PERIOD_D1,0) == prevtime)  return(0);
   prevtime = iTime(Symbol(),PERIOD_D1,0);

   int _total=OrdersTotal();
   if (_total>0) {
      if (OrderSelect(_total-1,SELECT_BY_POS)) {
         OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3);
      }
   }
   int cmd=Signal();
   
   double _cmd=iif(cmd==OP_BUY,1,-1);
   double spred=Ask-Bid;
   double Price=iif(cmd==OP_BUY,Ask,Bid);
   color OpenCl=iif(_cmd>0,Blue,Red);
   Order_Open(Symbol(), cmd, Price, 0,0,0, OpenCl);

   return(0);
}

int Order_Open(string _Symbol, int OP_CMD, double Price, double _TP, double _SL, int Magic, color Opencl){
   return(OrderSend(_Symbol, OP_CMD, getLots(), Price, 3, _SL, _TP, "", Magic, 0, Opencl));
}


int Signal(){
   int cmd=0;
   int P1=CalculatePrice(iOpen(Symbol(),PERIOD_D1,1)/Point);
   int P2=CalculatePrice(iHigh(Symbol(),PERIOD_D1,1)/Point);
   int P3=CalculatePrice(iLow(Symbol(),PERIOD_D1,1)/Point);   
   int P4=CalculatePrice(iClose(Symbol(),PERIOD_D1,1)/Point);
   int P5,P6;

   if (iOpen(Symbol(),PERIOD_D1,1)>iClose(Symbol(),PERIOD_D1,1)) {
      P5=CalculatePrice(P1+P2);
      P6=CalculatePrice(P3+P4);
   }
   if (iOpen(Symbol(),PERIOD_D1,1)<iClose(Symbol(),PERIOD_D1,1)) {
      P5=CalculatePrice(P1+P3);
      P6=CalculatePrice(P2+P4);
   }
   if (P5>P6) cmd=OP_BUY; else cmd=OP_SELL;   
   return(cmd);
}

double iif(bool a, double b, double c){if(a) return(b);return(c);}

//   ,      
int CalculatePrice(double price){
   int s=0;
   int tmp1=price;
   int tmp2;
   while (tmp1>0){
      tmp2=tmp1%10;
      s+=tmp2;
      tmp1=(tmp1-tmp2)/10;
   }
   return(s);
}

double getLots() {
   if (MaximumRisk>0) {
      double minlot=MarketInfo(Symbol(),MODE_MINLOT);
      double maxlot = MarketInfo(Symbol(), MODE_MAXLOT);       
      double step=MarketInfo(Symbol(),MODE_LOTSTEP);

      double lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk / 100000.0/step, 0)*step; 
      lot=MathMax(MathMin(lot,maxlot),minlot);
      
   }
   else lot=Lots;
   return(lot); 
}